Fixed VNF descriptor for tests
[osm/RO.git] / test / basictest.sh
index 91e87ec..9c7b888 100755 (executable)
@@ -36,6 +36,7 @@ function usage(){
     echo -e "  OPTIONS:"
     echo -e "    -f --force       does not prompt for confirmation"
     echo -e "    -h --help        shows this help"
+    echo -e "    --screen         forces to run openmano (and openvim) service in a screen"
     echo -e "    --insert-bashrc  insert the created tenant,datacenter variables at"
     echo -e "                     ~/.bashrc to be available by openmano CLI"
     echo -e "    --init-openvim   if openvim runs locally, an init is called to clean openvim"
@@ -48,49 +49,46 @@ function is_valid_uuid(){
 }
 
 #detect if is called with a source to use the 'exit'/'return' command for exiting
+DIRNAME=$(dirname $(readlink -f ${BASH_SOURCE[0]}))
+DIRmano=$(dirname $DIRNAME)
+DIRscript=${DIRmano}/scripts
+
 [[ ${BASH_SOURCE[0]} != $0 ]] && _exit="return" || _exit="exit"
 
 
+#process options
+source ${DIRscript}/get-options.sh "force:f help:h insert-bashrc init-openvim screen" $* || $_exit 1
+
+#help
+[ -n "$option_help" ] && usage && $_exit 0
+
 #check correct arguments
-force=""
+force_param="" && [[ -n "$option_force" ]] && force_param=" -f"
+insert_bashrc_param="" && [[ -n "$option_insert_bashrc" ]] && insert_bashrc_param=" --insert-bashrc"
+screen_mano_param="" && [[ -n "$option_screen" ]] && screen_mano_param=" --screen-name=mano" 
+screen_vim_param=""  && [[ -n "$option_screen" ]] && screen_vim_param=" --screen-name=vim" 
+
 action_list=""
-insert_bashrc=""
-init_openvim=""
-for param in $*
+
+for argument in $params
 do
-    if [[ $param == reset ]] || [[ $param == create ]] || [[ $param == delete ]]
+    if [[ $argument == reset ]] || [[ $argument == create ]] || [[ $argument == delete ]]
     then
-        action_list="$action_list $param"
-    elif [[ $param == -h ]] || [[ $param == --help ]]
-    then
-        usage
-        $_exit 0
-    elif [[ $param == -f ]] || [[ $param == --force ]]
-    then
-        force="-f"
-    elif [[ $param == --insert-bashrc ]]
-    then
-        insert_bashrc=y
-    elif [[ $param == --init-openvim ]]
-    then
-        init_openvim=y
-    else
-        echo "invalid argument '$param'?  Type -h for help" >&2 && $_exit 1
+        action_list="$action_list $argument"
+        continue
     fi
+    echo "invalid argument '$argument'?  Type -h for help" >&2 && $_exit 1
 done
 
-DIRNAME=$(dirname $(readlink -f ${BASH_SOURCE[0]}))
-DIRmano=$(dirname $DIRNAME)
-DIRscript=${DIRmano}/scripts
 export OPENMANO_HOST=localhost
 export OPENMANO_PORT=9090
-[[ $insert_bashrc == y ]] && echo -e "\nexport OPENMANO_HOST=localhost"  >> ~/.bashrc
-[[ $insert_bashrc == y ]] && echo -e "\nexport OPENMANO_PORT=9090"  >> ~/.bashrc
+[[ -n "$option_insert_bashrc" ]] && echo -e "\nexport OPENMANO_HOST=localhost"  >> ~/.bashrc
+[[ -n "$option_insert_bashrc" ]] && echo -e "\nexport OPENMANO_PORT=9090"  >> ~/.bashrc
 
 
 #by default action should be reset and create
 [[ -z $action_list ]]  && action_list="reset create delete"
-[[ -z $init_openvim ]] || initopenvim $force || echo "WARNING openvim cannot be initialized. The rest of test can fail!"
+[[ -z "$option_init_openvim" ]] || initopenvim${force_param}${insert_bashrc_param}${screen_vim_param} || echo "WARNING openvim cannot be initialized. The rest of test can fail!"
 
 #check openvim client variables are set
 #fail=""
@@ -114,15 +112,15 @@ then
 
     #ask for confirmation if argument is not -f --force
     force_=y
-    [[ -z $force ]] && read -e -p "WARNING: reset openmano database, content will be lost!!! Continue(y/N) " force_
+    [[ -z "$option_force" ]] && read -e -p "WARNING: reset openmano database, content will be lost!!! Continue(y/N) " force_
     [[ $force_ != y ]] && [[ $force_ != yes ]] && echo "aborted!" && $_exit
 
     echo "Stopping openmano"
-    $DIRscript/service-openmano.sh mano stop
+    $DIRscript/service-openmano.sh mano stop${screen_mano_param}
     echo "Initializing openmano database"
-    $DIRmano/database_utils/init_mano_db.sh -u mano -p manopw
+    $DIRmano/database_utils/init_mano_db.sh -u mano -p manopw --createdb
     echo "Starting openmano"
-    $DIRscript/service-openmano.sh mano start
+    $DIRscript/service-openmano.sh mano start${screen_mano_param}
     echo
 
 elif [[ $action == "delete" ]]
@@ -135,16 +133,25 @@ then
     ${DIRmano}/openmano instance-scenario-delete -f simple-instance     || echo "fail"
     ${DIRmano}/openmano instance-scenario-delete -f complex-instance    || echo "fail"
     ${DIRmano}/openmano instance-scenario-delete -f complex2-instance   || echo "fail"
-    ${DIRmano}/openmano scenario-delete -f simple       || echo "fail"
-    ${DIRmano}/openmano scenario-delete -f complex      || echo "fail"
-    ${DIRmano}/openmano scenario-delete -f complex2     || echo "fail"
-    ${DIRmano}/openmano vnf-delete -f linux             || echo "fail"
-    ${DIRmano}/openmano vnf-delete -f dataplaneVNF_2VMs || echo "fail"
-    ${DIRmano}/openmano vnf-delete -f dataplaneVNF2     || echo "fail"
-    ${DIRmano}/openmano vnf-delete -f dataplaneVNF3     || echo "fail"
-    ${DIRmano}/openmano datacenter-detach TEST-dc        || echo "fail"
-    ${DIRmano}/openmano datacenter-delete -f TEST-dc     || echo "fail"
-    ${DIRmano}/openmano tenant-delete -f TEST-tenant     || echo "fail"
+    ${DIRmano}/openmano instance-scenario-delete -f complex3-instance   || echo "fail"
+    ${DIRmano}/openmano instance-scenario-delete -f complex4-instance   || echo "fail"
+    ${DIRmano}/openmano instance-scenario-delete -f complex5-instance   || echo "fail"
+    ${DIRmano}/openmano scenario-delete -f simple           || echo "fail"
+    ${DIRmano}/openmano scenario-delete -f complex          || echo "fail"
+    ${DIRmano}/openmano scenario-delete -f complex2         || echo "fail"
+    ${DIRmano}/openmano scenario-delete -f complex3         || echo "fail"
+    ${DIRmano}/openmano scenario-delete -f complex4         || echo "fail"
+    ${DIRmano}/openmano scenario-delete -f complex5         || echo "fail"
+    ${DIRmano}/openmano vnf-delete -f linux                 || echo "fail"
+    ${DIRmano}/openmano vnf-delete -f linux_2VMs_v02        || echo "fail"
+    ${DIRmano}/openmano vnf-delete -f dataplaneVNF_2VMs     || echo "fail"
+    ${DIRmano}/openmano vnf-delete -f dataplaneVNF_2VMs_v02 || echo "fail"
+    ${DIRmano}/openmano vnf-delete -f dataplaneVNF4 || echo "fail"
+    ${DIRmano}/openmano vnf-delete -f dataplaneVNF2         || echo "fail"
+    ${DIRmano}/openmano vnf-delete -f dataplaneVNF3         || echo "fail"
+    ${DIRmano}/openmano datacenter-detach TEST-dc           || echo "fail"
+    ${DIRmano}/openmano datacenter-delete -f TEST-dc        || echo "fail"
+    ${DIRmano}/openmano tenant-delete -f TEST-tenant        || echo "fail"
     echo
 
 elif [[ $action == "create" ]]
@@ -155,7 +162,7 @@ then
     #check a valid uuid is obtained
     ! is_valid_uuid $nfvotenant && echo "FAIL" && echo "    $result" && $_exit 1
     export OPENMANO_TENANT=$nfvotenant
-    [[ $insert_bashrc == y ]] && echo -e "\nexport OPENMANO_TENANT=$nfvotenant"  >> ~/.bashrc
+    [[ -n "$option_insert_bashrc" ]] && echo -e "\nexport OPENMANO_TENANT=$nfvotenant"  >> ~/.bashrc
     echo $nfvotenant
 
     printf "%-50s" "Creating datacenter 'TEST-dc' in openmano:"
@@ -169,7 +176,7 @@ then
     ! is_valid_uuid $datacenter && echo "FAIL" && echo "    $result" && $_exit 1
     echo $datacenter
     export OPENMANO_DATACENTER=$datacenter
-    [[ $insert_bashrc == y ]] && echo -e "\nexport OPENMANO_DATACENTER=$datacenter"  >> ~/.bashrc
+    [[ -n "$option_insert_bashrc" ]] && echo -e "\nexport OPENMANO_DATACENTER=$datacenter"  >> ~/.bashrc
 
     printf "%-50s" "Attaching openmano tenant to the datacenter:"
     result=`${DIRmano}/openmano datacenter-attach TEST-dc`
@@ -179,11 +186,11 @@ then
     printf "%-50s" "Updating external nets in openmano: "
     result=`${DIRmano}/openmano datacenter-netmap-delete -f --all`
     [[ $? != 0 ]] && echo  "FAIL" && echo "    $result"  && $_exit 1
-    result=`${DIRmano}/openmano datacenter-netmap-upload -f`
+    result=`${DIRmano}/openmano datacenter-netmap-import -f`
     [[ $? != 0 ]] && echo  "FAIL" && echo "    $result"  && $_exit 1
     echo OK
 
-    for VNF in linux dataplaneVNF1 dataplaneVNF2 dataplaneVNF_2VMs dataplaneVNF3
+    for VNF in linux dataplaneVNF1 dataplaneVNF2 dataplaneVNF_2VMs dataplaneVNF_2VMs_v02 dataplaneVNF3 linux_2VMs_v02 dataplaneVNF4
     do    
         printf "%-50s" "Creating VNF '${VNF}': "
         result=`$DIRmano/openmano vnf-create $DIRmano/vnfs/examples/${VNF}.yaml`
@@ -192,7 +199,7 @@ then
         ! is_valid_uuid $vnf && echo FAIL && echo "    $result" &&  $_exit 1
         echo $vnf
     done
-    for NS in simple complex complex2
+    for NS in simple complex complex2 complex3 complex4 complex5
     do
         printf "%-50s" "Creating scenario '${NS}':"
         result=`$DIRmano/openmano scenario-create $DIRmano/scenarios/examples/${NS}.yaml`
@@ -201,7 +208,7 @@ then
         echo $scenario
     done
 
-    for IS in simple complex complex2
+    for IS in simple complex complex2 complex3 complex5
     do
         printf "%-50s" "Creating instance-scenario '${IS}':"
         result=`$DIRmano/openmano instance-scenario-create  --scenario ${IS} --name ${IS}-instance`
@@ -210,6 +217,12 @@ then
         echo $instance
     done
 
+    printf "%-50s" "Creating instance-scenario 'complex4':"
+    result=`$DIRmano/openmano instance-scenario-create $DIRmano/instance-scenarios/examples/instance-creation-complex4.yaml`
+    instance=`echo $result |gawk '{print $1}'`
+    ! is_valid_uuid $instance && echo FAIL && echo "    $result" &&  $_exit 1
+    echo $instance
+
     echo
     #echo "Check virtual machines are deployed"
     #vms_error=`openvim vm-list | grep ERROR | wc -l`